package net.hostsharing.cas.auth;

import org.apereo.cas.authentication.AuthenticationEventExecutionPlanConfigurer;
import org.apereo.cas.authentication.AuthenticationHandler;
import org.apereo.cas.authentication.principal.PrincipalFactoryUtils;
import org.apereo.cas.configuration.CasConfigurationProperties;
import org.apereo.cas.services.ServicesManager;
import org.springframework.beans.factory.ObjectProvider;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.autoconfigure.AutoConfiguration;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;

@AutoConfiguration
@EnableConfigurationProperties(CasConfigurationProperties.class)
public class HostsharingEMailAuthenticationConfiguration {

    @Autowired
    @Qualifier("servicesManager")
    private ObjectProvider<ServicesManager> servicesManager;

	@Bean
	public AuthenticationHandler emailAuthenticationConfiguration(final CasConfigurationProperties casProperties) {
		
		return new HostsharingAuthenticationHandler("Hostsharing EMail", servicesManager.getObject(), 
				PrincipalFactoryUtils.newPrincipalFactory(), Integer.valueOf(1));
	}
	
    @Bean
    public AuthenticationEventExecutionPlanConfigurer emailAuthenticationPlan(
        @Qualifier("emailAuthenticationConfiguration")
        final AuthenticationHandler emailAuthenticationConfiguration) {
        return plan -> {
            plan.registerAuthenticationHandler(emailAuthenticationConfiguration);
        };
    }
}
